Blob


1 #!/bin/sh
2 #
3 # Copyright (c) 2019 Stefan Sperling <stsp@openbsd.org>
4 #
5 # Permission to use, copy, modify, and distribute this software for any
6 # purpose with or without fee is hereby granted, provided that the above
7 # copyright notice and this permission notice appear in all copies.
8 #
9 # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
17 export GIT_AUTHOR_NAME="Flan Hacker"
18 export GIT_AUTHOR_EMAIL="flan_hacker@openbsd.org"
19 export GIT_COMMITTER_NAME="$GIT_AUTHOR_NAME"
20 export GIT_COMMITTER_EMAIL="$GIT_AUTHOR_EMAIL"
21 export GOT_AUTHOR="$GIT_AUTHOR_NAME <$GIT_AUTHOR_EMAIL>"
22 export GOT_AUTHOR_8="flan_hac"
23 export GOT_LOG_DEFAULT_LIMIT=0
25 export MALLOC_OPTIONS=S
27 function git_init
28 {
29 git init -q "$1"
30 }
32 function git_commit
33 {
34 local repo="$1"
35 shift
36 (cd $repo && git commit --author="$GOT_AUTHOR" -q -a "$@")
37 }
39 function git_rm
40 {
41 local repo="$1"
42 shift
43 (cd $repo && git rm -q "$@")
44 }
46 function git_show_head
47 {
48 local repo="$1"
49 (cd $repo && git show --no-patch --pretty='format:%H')
50 }
52 function git_show_author_time
53 {
54 local repo="$1"
55 local object="$2"
56 (cd $repo && git show --no-patch --pretty='format:%at' $object)
57 }
59 function git_show_tagger_time
60 {
61 local repo="$1"
62 local tag="$2"
63 (cd $repo && git cat-file tag $tag | grep ^tagger | \
64 sed -e "s/^tagger $GOT_AUTHOR//" | cut -d' ' -f2)
65 }
67 function git_show_parent_commit
68 {
69 local repo="$1"
70 (cd $repo && git show --no-patch --pretty='format:%P')
71 }
73 function git_show_tree
74 {
75 local repo="$1"
76 (cd $repo && git show --no-patch --pretty='format:%T')
77 }
79 function trim_obj_id
80 {
81 let trimcount=$1
82 id=$2
84 pat=""
85 while [ trimcount -gt 0 ]; do
86 pat="[0-9a-f]$pat"
87 let trimcount--
88 done
90 echo ${id%$pat}
91 }
93 function git_commit_tree
94 {
95 local repo="$1"
96 local msg="$2"
97 local tree="$3"
98 (cd $repo && git commit-tree -m "$msg" "$tree")
99 }
101 function make_test_tree
103 repo="$1"
105 echo alpha > $repo/alpha
106 echo beta > $repo/beta
107 mkdir $repo/gamma
108 echo delta > $repo/gamma/delta
109 mkdir $repo/epsilon
110 echo zeta > $repo/epsilon/zeta
113 function get_blob_id
115 repo="$1"
116 tree_path="$2"
117 filename="$3"
119 got tree -r $repo -i $tree_path | grep ${filename}$ | cut -d' ' -f 1
122 function test_init
124 local testname="$1"
125 local no_tree="$2"
126 if [ -z "$testname" ]; then
127 echo "No test name provided" >&2
128 return 1
129 fi
130 local testroot=`mktemp -p /tmp -d got-test-$testname-XXXXXXXX`
131 mkdir $testroot/repo
132 git_init $testroot/repo
133 if [ -z "$no_tree" ]; then
134 make_test_tree $testroot/repo
135 (cd $repo && git add .)
136 git_commit $testroot/repo -m "adding the test tree"
137 fi
138 echo "$testroot"
141 function test_cleanup
143 local testroot="$1"
145 (cd $testroot/repo && git fsck --strict \
146 > $testroot/fsck.stdout 2> $testroot/fsck.stderr)
147 ret="$?"
148 if [ "$ret" != "0" ]; then
149 echo -n "git fsck: "
150 cat $testroot/fsck.stderr
151 echo "git fsck failed; leaving test data in $testroot"
152 return 1
153 fi
155 rm -rf "$testroot"
158 function run_test
160 testfunc="$1"
161 echo -n "$testfunc "
162 $testfunc
165 function test_done
167 local testroot="$1"
168 local result="$2"
169 if [ "$result" == "0" ]; then
170 test_cleanup "$testroot" || return 1
171 echo "ok"
172 elif echo "$result" | grep -q "^xfail"; then
173 # expected test failure; test reproduces an unfixed bug
174 echo "$result"
175 test_cleanup "$testroot" || return 1
176 else
177 echo "test failed; leaving test data in $testroot"
178 fi